
#------------------------------------------------------------------------------
#
# 1. DISCLAIMER
#    THE SOFTWARE AND/OR RELATED MATERIALS ARE PROVIDED "AS-IS" WITHOUT
#    WARRANTY OF ANY KIND INCLUDING ANY WARRANTIES OF PERFORMANCE OR
#    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE OR PURPOSE (AS SET FORTH
#    IN UCC 2312-2313) OR FOR ANY PURPOSE WHATSOEVER, FOR THE LICENSED
#    PRODUCT, HOWEVER USED.
#
#    IN NO EVENT SHALL CALTECH/JPL BE LIABLE FOR ANY DAMAGES AND/OR COSTS,
#    INCLUDING BUT NOT LIMITED TO INCIDENTAL OR CONSEQUENTIAL DAMAGES OF ANY
#    KIND, INCLUDING ECONOMIC DAMAGE OR INJURY TO PROPERTY AND LOST PROFITS,
#    REGARDLESS OF WHETHER CIT/JPL SHALL BE ADVISED, HAVE REASON TO KNOW,
#    OR IN FACT SHALL KNOW OF THE POSSIBILITY.
#
#    USER BEARS ALL RISK RELATING TO QUALITY AND PERFORMANCE OF THE SOFTWARE
#    AND/OR RELATED MATERIALS.
#
# 2. The user shall comply with all applicable U.S. export control laws and
#    regulations.  To the extent that the software is subject to U.S. export
#    control laws and regulations, the user has the responsibility to obtain
#    export licenses or other export authority as may be required before
#    exporting such information to foreign countries or providing access to
#    foreign persons.
#
#------------------------------------------------------------------------------

#########################################################################
# File Name: airs_utils.py						#
# Directory /home/rickf/Direct_Broadcast/bin/python/new_dev/Recovery	#
#									#
# Description:								#
#									#
# Developed as a component part of the AIRS Direct Broadcast system.	#
#########################################################################

#########################################################################

import string, os, pickle, time, fnmatch, re

MACHINE_ARCH = 'sun5.8'
LOG_NAME = 'UNKNOWN'
#########################################################################
def isNumeric(Str):
   for x in Str:
      if (not x in string.digits):
         return 0
   return 1

#########################################################################
def eduTest(PktName):
   EDU_FRAG = '\\021\\202'
   Path, FName = os.path.split(PktName)
   FD = open(PktName, 'r').read(50)
   INT = pickle.dumps(FD[4:9])
   RAW = pickle.dumps(FD[:9])
   if ((FName[0:5] == INT[2:7]) and (RAW[2:10] != EDU_FRAG)):
      return 0
   if ((FName[0:5] != INT[2:7]) and (RAW[2:10] == EDU_FRAG)):
      return 1
   return 0	# just in case it gets to here with something that snuck
   		# by both if tests.

#########################################################################
def getDateStr():
   NOW = time.localtime(time.time())
   FMT = '%Y%j-%H%M%S'

   TM_STR = time.strftime(FMT, NOW)
   return TM_STR

#########################################################################
def ParseTime(TM_STR):
   TM_DATE,TM_TIME = string.split(TM_STR, 'T')
   TM_TIME = string.replace(TM_TIME, 'Z', '')
   TM_PARTS = string.split(TM_DATE, '-')
   TM_PARTS = TM_PARTS[:] + string.split(TM_TIME, ':')
   TM_OFFSET = time.timezone

   return TM_PARTS

#########################################################################
def setArch():
   global MACHINE_ARCH
   if not os.environ.has_key('ARCH'):
      print 'ERROR: Environment variable ARCH not set'
      print 'ERROR: Assuming ARCH = \"sun5.8\"'
      MACHINE_ARCH = 'sun5.8'
   else:
      MACHINE_ARCH = os.environ['ARCH']
      if (MACHINE_ARCH == 'SUN'):
         MACHINE_ARCH = 'sun5.8'
      elif (MACHINE_ARCH == 'SGI'):
         MACHINE_ARCH = 'sgi64'
      elif ((MACHINE_ARCH == 'linux') or (MACHINE_ARCH == 'Linux')):
         MACHINE_ARCH = 'linux'
      else:
         MACHINE_ARCH = 'unknown'

#########################################################################
def getArch():
   return MACHINE_ARCH

#########################################################################
def getFType (FName):
   CMD = 'file ' + FName
   RESULTS = os.popen(CMD).readlines()
   string.replace(RESULTS[0], '\\011', '')
   string.replace(RESULTS[0], '\\012', '')
   TypeData = string.split(RESULTS[0], ':')
   Mark = string.find(TypeData[1], 'symbolic link to ')
   if (Mark >= 0):
      chunks = string.split(TypeData[1], ' ')
      NewFName = chunks[len(chunks)-1]
      FType = getFType(NewFName)
      TypeData = string.split(FType, ':')
   FileType = string.strip(TypeData[1])
   return FileType

#########################################################################
def canWriteTo(DirName):
   FName = os.path.join(DirName, "AIRSDB-TST.fn")

   try:
      OF = open(FName, 'w')
   except:
      return 0
   else:
      OF.write('Test String')
      OF.close()
      os.remove(FName)
      return 1
   return 0
########################################################################
def cleanup(WORKING_DIR):
   Pattern = fnmatch.translate("L[12][AB-]*")
   FileList = os.listdir(WORKING_DIR)
   for file in FileList:
      if re.match(Pattern, file):
        Ext = os.path.splitext(os.path.basename(file))[1]
	if (Ext != '.pcf'):
           os.remove(os.path.join(WORKING_DIR,file))
   

########################################################################
def setlog(LogName=''):
   global LOG_NAME
   global LOG

   if (LogName != ''):
      LOG_NAME = LogName
      LOG = open (LOG_NAME, 'w')
   else:
      try:
         LOG.write('\n')
      except ValueError:
         LOG = open(LOG_NAME, 'a+')
      except UnboundLocalError:
         LOG = open(LOG_NAME, 'a+')
      else:
         LOG = open(LOG_NAME, 'a+')

########################################################################
def logstr(fnc, msg):
   setlog()
   LOG.write('LOGMSG(%s): %s\n'%(fnc, msg))
 
########################################################################
def loglist(fnc, list, msg=''):
   logstr(fnc, msg)
   for item in list:
      LOG.write('%s\n' %(item))
 
########################################################################
