
#------------------------------------------------------------------------------
#
# 1. DISCLAIMER
#    THE SOFTWARE AND/OR RELATED MATERIALS ARE PROVIDED "AS-IS" WITHOUT
#    WARRANTY OF ANY KIND INCLUDING ANY WARRANTIES OF PERFORMANCE OR
#    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE OR PURPOSE (AS SET FORTH
#    IN UCC 2312-2313) OR FOR ANY PURPOSE WHATSOEVER, FOR THE LICENSED
#    PRODUCT, HOWEVER USED.
#
#    IN NO EVENT SHALL CALTECH/JPL BE LIABLE FOR ANY DAMAGES AND/OR COSTS,
#    INCLUDING BUT NOT LIMITED TO INCIDENTAL OR CONSEQUENTIAL DAMAGES OF ANY
#    KIND, INCLUDING ECONOMIC DAMAGE OR INJURY TO PROPERTY AND LOST PROFITS,
#    REGARDLESS OF WHETHER CIT/JPL SHALL BE ADVISED, HAVE REASON TO KNOW,
#    OR IN FACT SHALL KNOW OF THE POSSIBILITY.
#
#    USER BEARS ALL RISK RELATING TO QUALITY AND PERFORMANCE OF THE SOFTWARE
#    AND/OR RELATED MATERIALS.
#
# 2. The user shall comply with all applicable U.S. export control laws and
#    regulations.  To the extent that the software is subject to U.S. export
#    control laws and regulations, the user has the responsibility to obtain
#    export licenses or other export authority as may be required before
#    exporting such information to foreign countries or providing access to
#    foreign persons.
#
#------------------------------------------------------------------------------

#########################################################################
# File Name: esdt.py							#
# Directory: /home/rickf/Direct_Broadcast/bin/python/new_dev/Recovery	#
#########################################################################
import string
ESDT_TBL={}

class ESDT_REC:

   def set_short(self, str):
      self.short_name = str

   def get_short(self):
      return self.short_name

   def set_desc(self, str):
      self.description = str

   def get_desc(self):
      return self.description

   def gen_LGID_Name(self, Fld_1):
      LGID_Name = ['LGID', 'SHORTNAME', '001', Fld_1]
      LGID_Name[1] = self.get_short()
      return string.join(LGID_Name, ':')

   def __init__(self, sn, desc, Key):
      self.short_name = sn
      self.description = desc
      self.LID = str(Key)

def gen_esdt_tbl():
   ESDT_TBL[257] = ESDT_REC("AIR10XNM",
                            "AMSU-A1 packets APID 257 (No Mode)", 257)
   ESDT_TBL[259] = ESDT_REC("AIRAACAL",
                            "AMSU-A1 packets APID 259 (Staring 1)", 259)
   ESDT_TBL[260] = ESDT_REC("AIRASCAL",
                            "AMSU-A1 packets APID 260 (Staring 2)", 260)
   ESDT_TBL[261] = ESDT_REC("AIR10SCC",
                            "AMSU-A1 packets APID 261 (Full scan 1)", 261)
   ESDT_TBL[262] = ESDT_REC("AIR10SCI",
                            "AMSU-A1 packets APID 262 (Full scan 2)", 262)
   ESDT_TBL[288] = ESDT_REC("AIR20XNM",
                            "AMSU-A2 packets APID 288 (No Mode)", 288)
   ESDT_TBL[289] = ESDT_REC("AIR20XSM",
                            "AMSU-A2 packets APID 289 (Staring)", 289)
   ESDT_TBL[290] = ESDT_REC("AIR20SCI",
                            "AMSU-A2 packets APID 290 (Full scan)", 290)
   ESDT_TBL[342] = ESDT_REC("AIRH0ScE",
                            "HSB packets APID 342", 342)
   ESDT_TBL[404] = ESDT_REC("AIRB0SCI",
                            "packets APID 404 AIRS Scene", 404)
   ESDT_TBL[405] = ESDT_REC("AIRB0CAL",
                            "packets APID 405 AIRS spacelook", 405)
   ESDT_TBL[406] = ESDT_REC("AIRB0CAH",
                            "packets APID 406 AIRS blackbody", 406)
   ESDT_TBL[407] = ESDT_REC("AIRB0CAP",
                            "packets APID 407 AIRS", 407)
   ESDT_TBL[414] = ESDT_REC("AIRH1ENC",
                            "packets APID 414 AIRS std HR Eng #1", 414)
   ESDT_TBL[415] = ESDT_REC("AIRH2ENC",
                            "packets APID 415 AIRS std HR Eng #2", 415)
   ESDT_TBL[416] = ESDT_REC("AIRH1ENG",
                            "packets APID 416 AIRS flex HR Eng #1", 416)
   ESDT_TBL[417] = ESDT_REC("AIRH2ENG",
                            "packets APID 417 AIRS flex HR Eng #2", 417)
   ESDT_TBL[2001] = ESDT_REC("AIRI2TMC",
                            "AIRS IR Channel Transmittances", 2001)
   ESDT_TBL[2002] = ESDT_REC("AIRA2TMC",
                            "AMSU Transmittances", 2002)
   ESDT_TBL[2003] = ESDT_REC("AIRH2TMC",
                            "HSB Transmittances", 2003)
   ESDT_TBL[2005] = ESDT_REC("AIRX2CLI",
                            "Climatology to set initial guess profiles", 2005)
   ESDT_TBL[2006] = ESDT_REC("AIRX2AAC",
                            "Angle Correction Coefficients", 2006)
   ESDT_TBL[2007] = ESDT_REC("AIRX2AEI",
                            "Ancillary error estimate inputs", 2007)
   ESDT_TBL[2008] = ESDT_REC("AIRX2ABT",
                            "BRTemp Tuning Coefficients", 2008)
   ESDT_TBL[2009] = ESDT_REC("AIRI2SRD",
                            "Solar radiances", 2009)
   ESDT_TBL[2011] = ESDT_REC("AIRM2MEC",
                            "MW emissivity coefficients", 2011)
   ESDT_TBL[2012] = ESDT_REC("AIRM2MCM",
                            "MW temperature profile covariance matrix", 2012)
   ESDT_TBL[2013] = ESDT_REC("AIRH2AAW",
                            "HSB ASCII Weight", 2013)
   ESDT_TBL[2014] = ESDT_REC("AIRI2CHP",
                            "AIRS Channel properties", 2014)
   ESDT_TBL[2015] = ESDT_REC("AIRI2OLR",
                            "Outgoing Longwave Radiation Coefficients", 2015)
   ESDT_TBL[2021] = ESDT_REC("AIRX2ICW",
                            "FIRST cloud clearing weighting function", 2021)
   ESDT_TBL[2041] = ESDT_REC("AIRI2FEV",
                            "FIRST retrieval first guess matrix of", 2041)
   ESDT_TBL[2042] = ESDT_REC("AIRI2FEV",
                            "FIRST retrieval first guess matrix of", 2042)
   ESDT_TBL[2043] = ESDT_REC("AIRI2FRC",
                            "FIRST first guess principal component", 2043)
   ESDT_TBL[2044] = ESDT_REC("AIRI2FRC",
                            "FIRST first guess principal component", 2044)
   ESDT_TBL[2045] = ESDT_REC("AIRI2IFC",
                            "FIRST retrieval first guess eigenvectors", 2045)
   ESDT_TBL[2046] = ESDT_REC("AIRX2ANG",
                            "Principle components for angle adjustment", 2046)
   ESDT_TBL[2051] = ESDT_REC("AIRX2ICM",
                            "FIRST physical retrieval covariance", 2051)
   ESDT_TBL[2052] = ESDT_REC("AIRX2ITC",
                            "FIRST retrieval temperature channel list", 2052)
   ESDT_TBL[2053] = ESDT_REC("AIRX2IWC",
                            "FIRST retrieval water channel list for", 2053)
   ESDT_TBL[2061] = ESDT_REC("AIRX2NLD",
                            "Namelist giving default values for L2", 2061)
   ESDT_TBL[2065] = ESDT_REC("AIRV2PRM",
                            "V/NIR parameters", 2065)
   ESDT_TBL[2068] = ESDT_REC("AIRVBVIM",
                            "V/NIR surface map from AVHRR or multiday Vis map PGE", 2068)
   ESDT_TBL[2071] = ESDT_REC("AIRX2SUP",
                            "AIRS Level-2 support product TRUTH", 2071)
   ESDT_TBL[2081] = ESDT_REC("AIRI2CTB",
                            "AIRS L2 CC Browse Color table", 2081)
   ESDT_TBL[2082] = ESDT_REC("AIRX2CTB",
                            "AIRS L2 Retrieval Browse Color table", 2082)
   ESDT_TBL[3005] = ESDT_REC("AIRXBPAR",
                            "Level-1B Calibration parameters", 3005)
   ESDT_TBL[3006] = ESDT_REC("AIRIBFRQ",
                            "AIRS frequency list", 3006)
   ESDT_TBL[3007] = ESDT_REC("AIRIBFPM",
                            "AIRS focal plane map", 3007)
   ESDT_TBL[3008] = ESDT_REC("AIRIBCPF",
                            "AIRS correction parameters", 3008)
   ESDT_TBL[3009] = ESDT_REC("AIRVBCPR",
                            "Vis calibration parameters", 3009)
   ESDT_TBL[3010] = ESDT_REC("AIRIBSFF",
                            "AIRS spectral features", 3010)
   ESDT_TBL[3011] = ESDT_REC("AIRIBNLC",
                            "AIRS Non linearity correction coefficients", 3011)
   ESDT_TBL[3012] = ESDT_REC("AIRIBPOL",
                            "AIRS polarization correction coefficients", 3012)
   ESDT_TBL[3013] = ESDT_REC("AIRIBSVS",
                            "AIRS space view selection parameters", 3013)
   ESDT_TBL[3014] = ESDT_REC("AIRIBPOP",
                            "AIRS popcorn correction parameters", 3014)
   ESDT_TBL[3015] = ESDT_REC("AIRIBQPR",
                            "AIRS QA parameters", 3015)
   ESDT_TBL[3101] = ESDT_REC("AIRIBCTB",
                            "AIRS L1B Browse Color table", 3101)
   ESDT_TBL[3501] = ESDT_REC("AIRABPAR",
                            "AMSU calibration parameters", 3501)
   ESDT_TBL[3502] = ESDT_REC("AIRABSLC",
                            "AMSU sidelobe correction matrices", 3502)
   ESDT_TBL[3504] = ESDT_REC("AIRABSLI",
                            "AMSU cold sidelobe interpolation arrays", 3504)
   ESDT_TBL[3601] = ESDT_REC("AIRHBPAR",
                            "HSB calibration parameters", 3601)
   ESDT_TBL[3602] = ESDT_REC("AIRHBSLC",
                            "HSB sidelobe correction matrices", 3602)
   ESDT_TBL[3604] = ESDT_REC("AIRHBSLI",
                            "HSB cold sidelobe interpolation arrays", 3604)
   ESDT_TBL[3701] = ESDT_REC("AIRABMLN",
                            "AMSU L1B Browse limb correction data - no sea", 3701)
   ESDT_TBL[3702] = ESDT_REC("AIRABMLS",
                            "AMSU L1B Browse limb correction data - sea", 3702)
   ESDT_TBL[3703] = ESDT_REC("AIRHBMLC",
                            "HSB L1B Browse limb correction data", 3703)
   ESDT_TBL[3704] = ESDT_REC("AIRABCTB",
                            "AMSU L1B Browse Color table", 3704)
   ESDT_TBL[3705] = ESDT_REC("AIRHBCTB",
                            "HSB L1B Browse Color table", 3705)
   ESDT_TBL[4001] = ESDT_REC("AIRXADCM",
                            "Decom Map", 4001)
   ESDT_TBL[4002] = ESDT_REC("AIRXATCM",
                            "Conversion method file", 4002)
   ESDT_TBL[4003] = ESDT_REC("AIRXATCS",
                            "Constant sets", 4003)
   ESDT_TBL[4005] = ESDT_REC("AIRXARYL",
                            "Red & Yellow limits", 4005)
   ESDT_TBL[4006] = ESDT_REC("AIRXAGEO",
                            "Geolocation parameters", 4006)
   ESDT_TBL[6211] = ESDT_REC("AIRIBRAD",
                            "AIRS geolocated radiances, previous granule", 6211)
   ESDT_TBL[6213] = ESDT_REC("AIRVBRAD",
                            "Vis geolocated radiances, previous granule", 6213)
   ESDT_TBL[6300] = ESDT_REC("AIRABRAD",
                            "AMSU-A geolocated brightness temperatures,", 6300)
   ESDT_TBL[6302] = ESDT_REC("AIRHBRAD",
                            "HSB geolocated brightness temperatures,", 6302)
   ESDT_TBL[6310] = ESDT_REC("AIRABRAD",
                            "AMSU-A geolocated brightness temperatures,", 6310)
   ESDT_TBL[6312] = ESDT_REC("AIRHBRAD",
                            "HSB geolocated brightness temperatures,", 6312)
   ESDT_TBL[7111] = ESDT_REC("AIRIACAL",
                            "AIRS IR geolocated calibration counts", 7111)
   ESDT_TBL[7113] = ESDT_REC("AIRVACAL",
                            "AIRS Vis/NIR geolocated calibration counts", 7113)
   ESDT_TBL[7120] = ESDT_REC("AIRAASCI",
                            "AMSU-A geolocated science counts", 7120)
   ESDT_TBL[7121] = ESDT_REC("AIRIASCI",
                            "AIRS IR geolocated science counts", 7121)
   ESDT_TBL[7122] = ESDT_REC("AIRHASCI",
                            "HSB geolocated science counts", 7122)
   ESDT_TBL[7123] = ESDT_REC("AIRVASCI",
                            "AIRS Vis/NIR geolocated science counts", 7123)
   ESDT_TBL[7130] = ESDT_REC("AIRIAHRE",
                            "AIRS/VIS High-Rate engineering archival product", 7130)
   ESDT_TBL[7140] = ESDT_REC("AIRBAQAP",
                            "AIRS/VIS Level-1A QA subset product", 7140)
   ESDT_TBL[7210] = ESDT_REC("AIRABRAD",
                            "AMSU-A geolocated brightness temperatures", 7210)
   ESDT_TBL[7211] = ESDT_REC("AIRIBRAD",
                            "AIRS geolocated radiances, current granule", 7211)
   ESDT_TBL[7212] = ESDT_REC("AIRHBRAD",
                            "HSB geolocated brightness temperatures,", 7212)
   ESDT_TBL[7213] = ESDT_REC("AIRVBRAD",
                            "Vis geolocated radiances, current granule", 7213)
   ESDT_TBL[7241] = ESDT_REC("AIRIBCBS",
                            "AIRS browse subset", 7241)
   ESDT_TBL[7251] = ESDT_REC("AIRIBQAP",
                            "AIRS Level-1B QA subset product", 7251)
   ESDT_TBL[7253] = ESDT_REC("AIRVBQAP",
                            "VIS Level-1B QA subset product", 7253)
   ESDT_TBL[7261] = ESDT_REC("AIRABDBR",
                            "AMSU-A daily browse package - ascending", 7261)
   ESDT_TBL[7262] = ESDT_REC("AIRIBDBR",
                            "AIRS daily browse package - ascending", 7262)
   ESDT_TBL[7263] = ESDT_REC("AIRHBDBR",
                            "HSB daily browse package - ascending", 7263)
   ESDT_TBL[7264] = ESDT_REC("AIRABDBR",
                            "AMSU-A daily browse package - descending", 7264)
   ESDT_TBL[7265] = ESDT_REC("AIRIBDBR",
                            "AIRS daily browse package - descending", 7265)
   ESDT_TBL[7266] = ESDT_REC("AIRHBDBR",
                            "HSB daily browse package - descending", 7266)
   ESDT_TBL[7300] = ESDT_REC("AIRX2RET",
                            "AIRS Level-2 standard product", 7300)
   ESDT_TBL[7301] = ESDT_REC("AIRI2CCF",
                            "AIRS Level-2 cloud-cleared radiance product", 7301)
   ESDT_TBL[7302] = ESDT_REC("AIRX2SUP",
                            "AIRS Level-2 support product", 7302)
   ESDT_TBL[7310] = ESDT_REC("AIRX2RBS",
                            "AIRS Level-2 retrieval browse subset product", 7310)
   ESDT_TBL[7311] = ESDT_REC("AIRI2CBS",
                            "Level-2 cleared browse subset", 7311)
   ESDT_TBL[7320] = ESDT_REC("AIRX2DBR",
                            "Level-2 retrieval browse package - ascending", 7320)
   ESDT_TBL[7321] = ESDT_REC("AIRI2DBR",
                            "Level-2 cloud-cleared browse package - ascending", 7321)
   ESDT_TBL[7322] = ESDT_REC("AIRX2ASD",
                            "Level-2 browse summary data - ascending", 7322)
   ESDT_TBL[7323] = ESDT_REC("AIRX2DBR",
                            "Level-2 retrieval browse package - descending", 7323)
   ESDT_TBL[7324] = ESDT_REC("AIRI2DBR",
                            "Level-2 cloud-cleared browse package - descending", 7324)
   ESDT_TBL[7325] = ESDT_REC("AIRX2ASD",
                            "Level-2 browse summary data - descending", 7325)
   ESDT_TBL[7401] = ESDT_REC("AIRX2MAT",
                            "Matchups of radiances, retrievals,", 7401)
   ESDT_TBL[7402] = ESDT_REC("AIRX2LOC",
                            "Truth location file", 7402)
   ESDT_TBL[8300] = ESDT_REC("AIRXSTAT",
                            "Statistics vs. truth", 8300)
   ESDT_TBL[8301] = ESDT_REC("AIRXGSTA",
                            "Granule Statistics vs. truth", 8301)
   ESDT_TBL[9257] = ESDT_REC("AIR10XNM",
                            "AMSU-A1 packets APID 257 (No Mode)", 9257)
   ESDT_TBL[9259] = ESDT_REC("AIRAACAL",
                            "AMSU-A1 packets APID 259 (Staring 1)", 9259)
   ESDT_TBL[9260] = ESDT_REC("AIRASCAL",
                            "AMSU-A1 packets APID 260 (Staring 2)", 9260)
   ESDT_TBL[9261] = ESDT_REC("AIR10SCC",
                            "AMSU-A1 packets APID 261 (Full scan 1)", 9261)
   ESDT_TBL[9262] = ESDT_REC("AIR10SCI",
                            "AMSU-A1 packets APID 262 (Full scan 2)", 9262)
   ESDT_TBL[9288] = ESDT_REC("AIR20XNM",
                            "AMSU-A2 packets APID 288 (No Mode)", 9288)
   ESDT_TBL[9289] = ESDT_REC("AIR20XSM",
                            "AMSU-A2 packets APID 289 (Staring)", 9289)
   ESDT_TBL[9290] = ESDT_REC("AIR20SCI",
                            "AMSU-A2 packets APID 290 (Full scan)", 9209)
   ESDT_TBL[9342] = ESDT_REC("AIRH0ScE",
                            "HSB packets APID 342", 9343)
   ESDT_TBL[9404] = ESDT_REC("AIRB0SCI",
                            "packets APID 404 AIRS Scene", 9404)
   ESDT_TBL[9405] = ESDT_REC("AIRB0CAL",
                            "packets APID 405 AIRS spacelook", 9405)
   ESDT_TBL[9406] = ESDT_REC("AIRB0CAH",
                            "packets APID 406 AIRS blackbody", 9406)
   ESDT_TBL[9407] = ESDT_REC("AIRB0CAP",
                            "packets APID 407 AIRS", 9407)
   ESDT_TBL[9414] = ESDT_REC("AIRH1ENC",
                            "packets APID 414 AIRS std HR Eng #1", 9414)
   ESDT_TBL[9415] = ESDT_REC("AIRH2ENC",
                            "packets APID 415 AIRS std HR Eng #2", 9415)
   ESDT_TBL[9416] = ESDT_REC("AIRH1ENG",
                            "packets APID 416 AIRS flex HR Eng #1", 9416)
   ESDT_TBL[9417] = ESDT_REC("AIRH2ENG",
                            "packets APID 417 AIRS flex HR Eng #2", 9417)
   ESDT_TBL[2010] = ESDT_REC("AIRX2CAV",
                            "Parameters determining channel averaging", 2010)
   ESDT_TBL[2014] = ESDT_REC("AIRI2CHP",
                            "AIRS Channel properties", 2014)
   ESDT_TBL[3016] = ESDT_REC("AIRVBQPR",
                            "Vis QA parameters", 3016)
   ESDT_TBL[7213] = ESDT_REC("AIRVBRAD",
                            "Vis geolocated radiances", 7213)
   ESDT_TBL[7250] = ESDT_REC("AIRABQAP",
                            "AMSU-A QA Support product", 7250)
   ESDT_TBL[7252] = ESDT_REC("AIRHBQAP",
                            "HSB QA Support product", 7252)
   ESDT_TBL[7270] = ESDT_REC("AIRVBVID",
                            "Daily vegetation map", 7270)
   ESDT_TBL[7271] = ESDT_REC("AIRVBVIM",
                            "Multi-day vegetation map", 7271)
   ESDT_TBL[7303] = ESDT_REC("AIRX2QAP",
                            "AIRS Level-2 QA Support product", 7303)
   ESDT_TBL[8300] = ESDT_REC("AIRXSTAT",
                            "Retrieval Statistics", 8300)
   ESDT_TBL[8301] = ESDT_REC("AIRXGSTA",
                            "Granule Statistics", 8301)
